;==========================================
;lbm.asm         (c)1994 Wagemakers S.                
;==========================================
%out tonen van een niet gekompreste LBM-file (640x480 16kl)                
%out dynamisch geheugen
%out eigen geheugen & file rountines
%out com programma
%out test van LBM-bestand
%out test van kompressie
%out test op aan aantal kleuren
%out andere formaten dan 640 x 480                
                .MODEL TINY
                .CODE
                ORG 100h
                EXTRN laad_LBM:         NEAR
start:
                mov bx,5000              ;
                mov ah,4ah               ;"memory resize" 
                int 21h                  ;
                push cs
                pop  ds   
                mov dx,offset tekst
                call zet_tekst
                mov ax,1a00h
                int 10h
                cmp al,1ah
                je start01
                mov dx,offset txt_geen_vga
                call zet_tekst
                jmp einde
start01:
                mov bx,82h              ;bx & di klaar zetten om 
                mov di,offset naam      ;bestandsnaam op te halen
                xor ch,ch
niet_ok:
                mov cl,es:[bx]          ;haal volgende karakter
                cmp cl,13           
                je ok
                cmp cl,32
                je ok
                mov [di],cl             ;zet in naam$
                inc bx
                inc di
                mov cl,0
                mov [di],cl
                inc ch
                jmp niet_ok
ok:
                cmp ch,0
                je fout
                mov dx,offset txt_laden
                call zet_tekst
                mov dx,offset naam
;--------------------- INIT = OK -------------------------------------;
                call laad_lbm
                jnc gedaan                        
                push cs
                pop ds
                cmp ax,0
                jne open_ok
fout:                
                mov dx,offset txt_fout  ;kan bestand
                call zet_tekst          ;            niet
                jmp einde               ;                 openen
open_ok:        cmp ax,1
                jne geh_ook_ok
                mov dx,offset txt_geh_fout
                call zet_tekst
                jmp einde
geh_ook_ok:     cmp ax,2
                jne lengte_ook_ok
                mov dx,offset txt_l_nk
                call zet_tekst
                jmp einde
lengte_ook_ok:  cmp ax,3
                jne toch_een_LBM
                mov dx,offset txt_geen_LBM
                call zet_tekst
                jmp einde
toch_een_LBM:   cmp ax,4
                jne niet_kompr
                mov dx,offset txt_compressie
                call zet_tekst
                jmp einde
niet_kompr:     mov dx,offset txt_kleur
                call zet_tekst
                jmp einde
;----------------- Stopppen ----------------------------;
gedaan:
                mov ax,0
                int 16h
                mov ax,3
                int 10h
                mov ax,cs
                mov ds,ax
                mov dx,offset txt_einde
                call zet_tekst
einde:          mov ah,4ch
                int 21h 
;---------------------------------------------;
;Zet een tekst op het scherm
;ds:dx -> pointer naar string
;---------------------------------------------;
zet_tekst       PROC    NEAR
                push ax
                mov ah,09h
                int 21h
                pop ax
                ret
zet_tekst       ENDP
naam            db 40 dup (0)
tekst           db "Ŀ",10,13
                db "LBM.COM   versie: 1.1a                    (c)1994  Wagemakers Staf Belgi ",10,13
                db "Toont een kleuren *.lbm file op het scherm (16 kleuren)                   ",10,13
                db "Kommando : lbm [bestand]                                                  ",10,13    
                db "",10,13,"$"
txt_einde       db "LBM.COM (c)1994 Wagemakers S.$"
txt_laden       db      "Laden van bestand ...$"
txt_fout        db 13,7,"Kan bestand niet lezen!!!$"
txt_geh_fout    db 13,7,"Geheugen fout!!!     $"
txt_geen_vga    db 13,7,"Sorry, dit programma heeft een VGA-kaart nodig.$"
txt_l_nk        db 13,7,"Sorry, bestand heeft niet de juiste lengte.$"
txt_geen_lbm    db 13,7,"Sorry, dit is geen LBM-bestand.$"
txt_compressie  db 13,7,"Sorry, dit een gekomprimeerde LBM! Deze worden (nog) niet ondersteund.$"
txt_kleur       db 13,7,"Sorry, dit is geen 16 - kleuren LBM! Deze worden (nog) niet ondersteund.$"
                END START
