.model small
.code
                PUBLIC readpixel
readpixel       PROC
                push bx
                push cx
                push dx
                push es
                push si
                mov ax,rp_y
                mov bx,rp_x
                call pixeladdr
                mov ch,ah
                shl ch,cl
                mov si,bx
                xor bl,bl
                mov dx,3ceh
                mov ax,304h
rp01:           out dx,ax
                mov bh,es:[si]
                and bh,ch
                neg bh
                rol bx,1
                dec ah
                jge rp01
                mov al,bl
                xor ah,ah
                pop si
                pop es
                pop dx
                pop cx
                pop bx
                ret
readpixel       ENDP
PUBLIC BOX
;------------------------------------------
;aanroep: call box
;         b_x1 .. b_y2 : kordinaten
;         b_kl1        : binnen kleur
;         l_kleur      : kader kleur 1
;         b_kl2        : kader kleur 2
;------------------------------------------
BOX             Proc
                push ax
                push bx
                push cx
                push dx
                call vlak
                mov  word ptr l_x1,ax
                mov  word ptr l_y1,bx
                mov  word ptr l_x2,dx
                mov  word ptr l_y2,bx
                call line
                push ax
                mov  ah,byte ptr l_kleur
                mov  al,byte ptr b_kl2
                mov  byte ptr l_kleur,al
                
                mov  word ptr l_y1,cx
                mov  word ptr l_y2,cx
                call line
                mov  word ptr l_x1,dx
                mov  word ptr l_y1,bx
                call line
                mov  byte ptr l_kleur,ah
                pop  ax   
                mov  word ptr l_x1,ax
                mov  word ptr l_x2,ax
                call line
                pop  dx
                pop  cx
                pop  bx
                pop  ax
                ret
BOX             ENDP
vlak            proc
                push si
                mov ax,word ptr b_x1
                mov bx,word ptr b_y1
                mov cx,word ptr b_y2
                mov dx,word ptr b_x2
                cmp ax,dx
                jng vlak01
                mov si,ax
                mov ax,dx
                mov dx,si
vlak01:
                cmp bx,cx
                jng vlak02
                mov si,bx
                mov bx,cx
                mov cx,si
vlak02:
                cmp ax,dx
                je vlak_ok
                cmp bx,cx
                je vlak_ok
                push ax
                push bx
                push cx
                push dx
                sub  cx,bx
                push cx
                mov  cl,byte ptr l_kleur
                mov  byte ptr temp,cl
                mov  cl,byte ptr b_kl1
                mov  byte ptr l_kleur,cl
                pop  cx
                mov  word ptr l_x1,ax
                mov  word ptr l_x2,dx
vlak03:
                mov  word ptr l_y1,bx
                mov  word ptr l_y2,bx
                call line
                inc  bx
                loop vlak03
                mov  cl,byte ptr temp
                mov  byte ptr l_kleur,cl
                pop  dx
                pop  cx
                pop  bx
                pop  ax
vlak_ok:                
                pop  si
                ret
vlak            ENDP 
PUBLIC Line
Line            proc
                push ax
                push bx
                push cx
                push dx
                push si
                push di
                push es
                mov dx,3ceh
                mov ah,l_kleur
                xor al,al
                out dx,ax
                mov ax,0f01h
                out dx,ax
                mov ah,RMWbits
                mov al,3
                out dx,ax
                mov si,80
                mov cx,l_x2
                sub cx,l_x1
                jz  vertline10
                jns l01
                neg cx
                mov bx,l_x2
                xchg bx,l_x1
                mov l_x2,bx
                mov bx,l_y2
                xchg bx,l_y1
                mov l_y2,bx
l01:
                mov bx,l_y2
                sub bx,l_y1
                jz Horizline10
                jns l03
                neg bx
                neg si
l03:
                mov VARvertincr,si
                mov VARroutine,offset LoSlopeLine10
                cmp bx,cx
                jle l04
                mov VARroutine,offset HiSlopeLine10
                xchg bx,cx
l04:
                shl bx,1
                mov VARincr1,bx
                sub bx,cx
                mov si,bx
                sub bx,cx
                mov VARincr2,bx
                push cx
                mov ax,l_y1
                mov bx,l_x1
                call PixelAddr
                mov di,bx
                shl ah,cl
                mov bl,ah
                mov al,8
                pop cx
                inc cx
                jmp word ptr Varroutine
vertline10:
                mov ax,l_y1
                mov bx,l_y2
                mov cx,bx
                sub cx,ax
                jge l31
                neg cx
                mov ax,bx
l31:
                inc cx
                mov bx,l_x1
                push cx
                call pixeladdr
                shl ah,cl
                mov al,8
                out dx,ax
                pop cx
l32:                    
                or es:[bx],al
                add bx,si
                loop l32
                jmp Lexit
horizLine10:
                push ds
                mov ax,l_y1
                mov bx,l_x1
                call pixeladdr
                mov di,bx
                mov dh,ah
                not dh
                shl dh,cl
                not dh
                mov cx,l_x2
                and cl,7
                xor cl,7
                mov dl,0ffh
                shl dl,cl
                mov ax,l_x2
                mov bx,l_x1
                mov cl,3
                shr ax,cl
                shr bx,cl
                mov cx,ax
                sub cx,bx
                mov bx,dx
                mov dx,3ceh
                mov al,8
                push es
                pop ds
                mov si,di
                or bh,bh
                js l43
                or cx,cx
                jnz l42
                and bl,bh
                jmp short l44
l42:
                mov ah,bh
                out dx,ax
                movsb
                dec cx
l43:
                mov ah,11111111b
                out dx,ax
                rep movsb
l44:
                mov ah,bl
                out dx,ax
                movsb
                pop ds
                jmp short Lexit

LoSlopeLine10:
l10:            mov ah,bl
l11:            or  ah,bl
                ror bl,1
                jc l14
                or si,si
                jns l12
                add si,VARincr1
                loop l11
                out dx,ax
                or es:[di],al
                jmp short Lexit
l12:            add si,VARincr2
                out dx,ax
                or es:[di],al
                add di,Varvertincr
                loop l10
                jmp short Lexit
l14:            out dx,ax
                or es:[di],al
                inc di
                or si,si
                jns l15
                add si,VARincr1
                loop l10
                jmp short Lexit
l15:            add si,VARincr2
                add di,VARvertincr
                loop l10
                jmp short Lexit
HiSlopeLine10:
                mov bx,VARvertincr
l21:            out dx,ax
                or es:[di],al
                add di,bx
l22:            or si,si
                jns l23
                add si,VARincr1
                loop l21
                jmp short Lexit
l23:            add si,VARincr2
                ror ah,1
                adc di,0
                loop l21
Lexit:          xor ax,ax
                out dx,ax
                inc ax
                out dx,ax
                mov al,3
                out dx,ax
                mov ax,0ff08h
                out dx,ax
                pop es
                pop di
                pop si
                pop dx
                pop cx
                pop bx
                pop ax
                ret
line            endp
                PUBLIC pixeladdr
Pixeladdr       proc                        
                ; ax = y / bx = x
                mov cl,bl
                push dx
                mov dx,80               ; ax = y *80
                mul dx
                pop dx
                shr bx,1
                shr bx,1
                shr bx,1                ; bx = x/8
                add bx,ax               ; bx = 80*y+x/8
                and cl,7
                xor cl,7
                ; cl = bitN in byte
                ; bx = ByteN
                mov ax,0a000h
                mov es,ax
                mov ah,1
                ret
Pixeladdr       endp                        
                PUBLIC
.data                        
PUBLIC          rp_x
PUBLIC          rp_y
PUBLIC          L_x1  
PUBLIC          L_x2
PUBLIC          L_y1
PUBLIC          L_y2
PUBLIC          L_Kleur 
PUBLIC          b_x1
PUBLIC          b_y1
PUBLIC          b_x2
PUBLIC          b_y2
PUBLIC          b_kl1
PUBLIC          b_kl2
PUBLIC          F_x
PUBLIC          F_y
PUBLIC          bordervalue
PUBLIC          argxc
PUBLIC          argyc
PUBLIC          arga
PUBLIC          argb
PUBLIC          argn
PUBLIC          RMWbits
rp_x            dw      0
rp_y            dw      0
l_x1            dw      0
l_x2            dw      0
l_y1            dw      0
l_y2            dw      0
l_kleur         db      0
b_x1            dw      0
b_y1            dw      0
b_x2            dw      0
b_y2            dw      0
b_kl1           db      0
b_kl2           db      0
temp            db      0
VARvertincr     dw      0
VARincr1        dw      0
VARincr2        dw      0
VARroutine      dw      0
f_x             dw      0
f_y             dw      0
bordervalue     db      0
argxc           dw      0
argyc           dw      0
arga            dw      0
argb            dw      0
argn            db      0
uladdr          dw      0
uraddr          dw      0
lladdr          dw      0
lraddr          dw      0
lmask           db      0
rmask           db      0
vard            dw      0
vardx           dw      0
vardy           dw      0
asquared        dw      0
bsquared        dw      0
twoasquared     dw      0
twobsquared     dw      0
rmwbits         db      0
bytesperline    equ     80
                        end
