%out Ŀ
%out DRW2ASM.ASM                      (c) 1993 Wagemakers Staf 
%out 
		.MODEL SMALL
		.CODE
		EXTRN   zet_tekst:      NEAR
		EXTRN   lees_xy:        NEAR
		EXTRN   gotoxy:         NEAR
		EXTRN   bereken_grootte:NEAR
		EXTRN   buf_rechth:     NEAR
		EXTRN   zet_rechth:     NEAR
;Ŀ
;Zet een venster op het scherm             
;aanroep : call win_open                   
;          DH/DL : begin regel/kolom       
;          CH/CL : eind regel/kolom        
;          AH    : attribuut               
;          BH    : 0 -> geen schaduw       
;                  1 -> schaduw            
;
		PUBLIC  WIN_OPEN
WIN_OPEN        proc    near
		push    dx
		push    dx
		push    cx
		push    ax
		call    bereken_geh ;AX = aantal para.'s nodig voor buffering
		call    buf_win     ;
		pop     ax
		pop     cx
		pop     dx
		mov     bl,dl
		mov     al,0DAh
		call    gotoxy                
		mov     dl,bl
win_open01:
		stosw                         
		inc     dl
		mov     al,0C4h
		cmp     dl,cl
		jl      win_open01              
		mov     al,0BFh
		stosw                           
		mov     al,0B3h
win_open02:
		mov     dl,bl
		inc     dh
		call    gotoxy                  
win_open03:
		stosw                           
		inc     dl
		mov     al,20h                  
		cmp     dl,cl
		jl      win_open03              
		mov     al,0B3h
		stosw                           
		cmp     dh,ch
		jl      win_open02              
		mov     dl,bl
		inc     dh
		call    gotoxy                  
		mov     al,0C0h
win_open04:
		stosw                           
		inc     dl
		mov     al,0C4h
		cmp     dl,cl
		jl      win_open04              
		mov     al,0D9h
		stosw                           
		mov     dl,bl
		cmp     bh,0
		je      win_open05              
		pop     bx
		push    bx
		call    teken_schaduw           
win_open05:
		pop     dx
		ret
win_open        endp
teken_schaduw           proc    near
		mov     dx,bx
		mov     al,7
		mov     dl,cl
		inc     dl
teken_schaduw01:
		inc     dh
		call    gotoxy                  
		inc     di
		stosb                           
		inc     di
		stosb                           
		inc     di
		cmp     dh,ch
		jle     teken_schaduw01         
		mov     dl,bl
		mov     dh,ch
		inc     dh
		inc     dh
		inc     dl
		inc     dl
		call    gotoxy                  
teken_schaduw02:
		inc     dl
		inc     di
		stosb                           
		cmp     dl,cl
		jle     teken_schaduw02         
		inc     di
		stosb                           
		inc     di
		stosb                           
		ret
teken_schaduw   endp
;Ŀ
;Bereken de geheugen grootte voor het      
;opslaan van een window                    
;aanroep :call bereken_geh                 
;             DX : begin regel/kolom       
;             CX : eind regel/kolom        
;antwoord: AX -> aantal paragraven         
;
		PUBLIC bereken_geh
bereken_geh     PROC    NEAR
		push bx
		push cx
		push dx
		add cl,3
		add ch,3
		mov  ax,cx
		call bereken_grootte
		mov  ax,bx
		xor  dx,dx
		mul  cx
		xor  dx,dx
		mov  cx,8
		div  cx
		add  ax,2
		pop  dx
		pop  cx
		pop  bx
		ret
bereken_geh     ENDP
;Ŀ
;Buffer de gegevens welke op de positie    
;staan waar het venster komt.              
;aanroep:       call buf_win               
;               DX : beginhoek             
;               CX : eindhoek              
;
buf_win         PROC    NEAR
		push ax
		push bx
		push cx
		push es
		add cl,3
		add ch,3
		call mem_alloc        ;vraag geheugen aan.  
		mov es,ax             ;ES -> segmentadres buffer.
		mov bl,byte ptr nr    ;bl = nr van laatst geopende venster. 
		add byte ptr nr,1     ;++nr 
		call seg_wijzer
		mov [bx],es
		xor bx,bx
		mov ax,cx
		call buf_rechth
		pop es
		pop bx
		pop cx
		pop ax
		ret
buf_win         endp
;Ŀ
;sluit het laatste venster                 
;aanroep:       call win_close             
;
		PUBLIC WIN_CLOSE
win_close       PROC    NEAR
		push ax
		push bx
		push dx
		push es
		mov bl,byte ptr nr
		dec bl
		mov byte ptr nr,bl
		call seg_wijzer
		mov ax,[bx]
		xor bx,bx
		mov es,ax
		call zet_rechth
		call mem_free
		pop es
		pop dx
		pop bx
		pop ax
		ret
win_close       ENDP
;Ŀ
;Geef het huidige venster een titel        
;aanroep : call win_titel                  
;            bx -> wijzer naar string      
;            ah -> kleur                   
;
		PUBLIC win_titel
win_titel       PROC    
		push ax
		push cx
		push dx
		push si
		push es
		mov si,bx
		mov ch,ah
		mov bl,byte ptr nr
		dec bl
		call seg_wijzer
		mov es,[bx]
		mov dx,word ptr es:[0000h]
		mov ax,word ptr es:[0002h]
		sub al,2
		pop es
		xor bx,bx
		push si
win_titel01:
		cmp byte ptr [si],0
		je win_titel02
		inc bx
		inc si
		jmp win_titel01
win_titel02:
		sub al,dl
		xor ah,ah
		shr al,1
		shr bl,1
		sub al,bl
		jg win_titel04
		inc dl
		call gotoxy
		jmp win_titel05
win_titel04:
		add al,dl
		mov dl,al
		call gotoxy
win_titel05:                
		mov ah,ch 
		pop si
win_titel03:                
		mov al,[si]
		cmp al,0
		je  win_titel_ok
		call lees_xy
		call test_x   
		jc win_titel_ok     
		stosw
		inc si
		jmp win_titel03
win_titel_ok:
		pop si
		pop dx
		pop cx
		pop ax
		ret
win_titel       ENDP
;Ŀ
;Zoek de juiste plaats van "buf_seg"       
;aanroep : call seg_wijzer                 
;antwoord: bx -> offset adres              
;
seg_wijzer      PROC                
		push    ax
		push    dx
		xor     dx,dx
		xor     bh,bh
		mov     ax,bx
		mov     bx,2
		mul     bx
		mov     bx,offset buf_seg
		add     bx,ax
		pop     dx
		pop     ax
		ret
seg_wijzer      ENDP
;Ŀ
;Zet DI op de juist plaats                 
;aanroep : call win_ga_xy                  
;          DH/DL : positie binnen venster     
;antwoord: DH/DL : werkelijke positie op   
;                  het scherm              
;
		PUBLIC win_ga_xy
win_ga_xy       PROC
		push    ax
		push    bx
		push    cx
		push    dx
		push    es
		mov     cx,dx
		mov     bl,byte ptr nr
		dec     bl
		call    seg_wijzer
		mov     ax,[bx]
		mov     es,ax
		mov     dx,word ptr es:[0000h]
		pop     es
		add     dl,cl
		add     dh,ch
		inc     dl
		inc     dh
		call    gotoxy
		pop     dx
		pop     cx
		pop     bx
		pop     ax
		ret
win_ga_xy       ENDP
		PUBLIC win_info
;Ŀ
;Geef de grootte van het venster door      
;aanroep : call win_info                   
;antwoord: dx -> beginhoek  cx-> eindhoek          
;
win_info        PROC
		push bx
		push es
		mov bl,byte ptr nr
		dec bl
		call seg_wijzer
		mov bx,[bx]
		mov es,bx
		mov dx,word ptr es:[0000h]
		mov cx,word ptr es:[0002h]
		sub cl,3
		sub ch,3
		pop es
		pop bx
		ret
win_info        ENDP
;Ŀ
;test of de x-kor. binnen het venster      
;vallen                                    
;aanroep : call test_x                     
;          al : begin x   cl : eind x      
;antwoord: C -> 0 : binnen venster         
;          C -> 1 : buiten venster         
;
test_x          PROC
		push    ax
		push    cx
		push    dx
		call    win_info
		mov     ax,dx
		pop     dx 
		cmp     dl,al
		jle     test_x01
		cmp     dl,cl
		jge     test_x01
		clc
		jmp test_x_ok
test_x01:       stc
test_x_ok:      
		pop     cx 
		pop     ax
		ret
test_x          endp
;Ŀ
;test of de y-kor. binnen het venster      
;vallen                                    
;aanroep : call test_y                     
;          ah : begin x   ch : eind x      
;antwoord: C -> 0 : binnen venster         
;          C -> 1 : buiten venster         
;
test_y          PROC
		push    ax
		push    cx
		push    dx
		call    win_info
		mov     ax,dx
		pop     dx
		cmp     dh,ah
		jle     test_y01
		cmp     dh,ch
		jg      test_y01
		clc
		jmp test_y_ok
test_y01:       stc
test_y_ok:      pop     cx
		pop     ax
		ret
test_y          endp
;Ŀ
;Zet een tekst in het huidige venster      
;aanroep : call win_tekst                  
;          bx : wijzer naar string         
;          ah : kleur                      
;          al : 00 -> normale werking      
;
		PUBLIC  win_tekst
win_tekst       proc    near
		push    ax
		push    bx
		push    cx
		push    dx
		push    si
		mov     si,bx
		mov     bx,ax
		call    win_info
		inc     dl
		mov     ax,dx
		call    lees_xy
		call    test_x
		jc      win_tekst03
		call    test_y
		jnc     win_tekst01
win_tekst03:
		xor     dx,dx
		call    win_ga_xy
		mov     dx,ax      ;grootte van venster
win_tekst01:
		mov     al,[si]
		inc     si
		cmp     al,0
		je      win_tekst_ok
		cmp     al,0Dh
		jne     win_tekst02
		inc     dh
		call    gotoxy
		jmp     short win_tekst01
win_tekst02:
		push    ax
		mov     ax,dx
		call    lees_xy
		call    test_x 
		jnc     win_tekst04
		mov     dx,ax
		inc     dh
		call    gotoxy
		mov     ax,dx
win_tekst04: 
		call    lees_xy
		call    test_y 
		mov     dx,ax 
		pop     ax
		jc win_tekst_ok
		mov     ah,bh
		stosw
		jmp win_tekst01
win_tekst_ok:
		pop si
		pop dx    
		pop cx
		pop bx
		pop ax    
		ret
win_tekst       endp
		PUBLIC win_tekstxy
win_tekstxy     PROC
		push dx
		call win_ga_xy
		pop dx
		call win_tekst
		ret
win_tekstxy     endp                
;Ŀ
;"ALLOCATE MEMORY"                                    
;aanroep : ax = aantal paragraven                     
;antwoord: CF = 0 -> ok!                              
;               AX = segmentadres                     
;          CF = 1 -> fout!                            
;               AX = foutkode                         
;                    07 = geh. kontrole vernietigd.   
;                    08 = te weinig geheugen.         
;
mem_alloc       PROC NEAR
		push cx
		push dx
		mov bx,ax
		mov ah,48h
		int 21h
		pop dx
		pop cx
		ret
mem_alloc       ENDP
;Ŀ
;aanroep : ax = segmentadres                                            
;antwoord: CF = 0 -> ok!                                                
;          CF = 1 -> fout!                                              
;               AX = foutkode                                           
;                    07 = geh. kontroleblok vernietigd.                 
;                    09 = geh. kontroleblok fout (fout segmentadres????)
;
mem_free        PROC NEAR
		push ax
		push bx
		push cx
		push dx
		mov es,ax
		mov ah,49h
		int 21h
		pop dx
		pop cx
		pop bx
		pop ax
		ret
mem_free        ENDP
		.data
nr              db 0
buf_seg         dw 256 dup(?)                
		END
